<?php
/*
Plugin Name: Instant Suggest
Plugin URI: http://www.instantsuggest.com/plugins/wordpress-plugin
Description: Suggests SEO content and keywords for your blog instantly: suggest keywords, check spell and autocomplete as you type.
Version: 1.0.3
Author: fuvidu
Author URI: http://www.instantsuggest.com/
License: GPLv2 or later
*/
?>
<?php 

function instantsuggest_add_buttons() {
    if(get_user_option('rich_editing')) {
        add_filter('mce_buttons', 'instantsuggest_register_buttons');
    }
}
add_action('init', 'instantsuggest_add_buttons');

function instantsuggest_register_buttons($buttons) {
   array_push($buttons, "|", "InstantSuggestStartSelectionButton", "InstantSuggestEndSelectionButton", "InstantSuggestSettingsDialogButton");
   return $buttons;
}

function instantsuggest_load_scripts() {
    global $pagenow, $wp_version;
    
    // Only load this for add new or edit post
    if($pagenow != 'post-new.php' && $pagenow != 'post.php') {
        return;
    }
    
    // Only load if user can edit with rich text editor
    if(!get_user_option('rich_editing')) {
        return;
    }
    
    $plugin_url = plugins_url('js/' , __FILE__ );
    $ver = urlencode('1.0.3');
    
    echo "<script type='text/javascript' src='{$plugin_url}instantsuggest.js?ver={$ver}'></script>\r\n";
    ?>

    <script type='text/javascript'>
        InstantSuggest.Event.domReady(function() {
            InstantSuggest.Env.platform = '<?php echo "WordPress $wp_version"?>';
                
            InstantSuggest.Ajax.jsonp({
                url: ajaxurl,
                dataType: 'json',
                data: {
                    action: 'instantsuggest_load_options',
                    security: '<?php echo wp_create_nonce("instantsuggest-load-options");?>'
                },
                success: function(jsonData) {
                    if(typeof jsonData === 'object') {
                        InstantSuggest.Preference.setCommonOptions(jsonData);
                        for(var suggestionServiceName in InstantSuggest.SuggestionServiceFactory.suggestionServices) {
                            if(!!jsonData[suggestionServiceName]) {
                                 var suggestionService = InstantSuggest.SuggestionServiceFactory.getSuggestionService(suggestionServiceName);
                                 suggestionService.options = jsonData[suggestionServiceName];
                            }
                        }
                    }
                }
            });
            
            InstantSuggest.Event.on('saveOptions', function(allOptions) {
                InstantSuggest.Ajax.jsonp({
                    url: ajaxurl,
                    data: {
                        action: 'instantsuggest_save_options',
                        security: '<?php echo wp_create_nonce("instantsuggest-save-options");?>',
                        options: allOptions
                    }
                });
            });
        });
    </script>
<?php
}
add_action('admin_print_footer_scripts', 'instantsuggest_load_scripts', 9999);

function instantsuggest_load_options() {
    check_ajax_referer('instantsuggest-load-options', 'security', true);
    $cb = $_GET['callback'];
    $options = get_user_option('instantsuggest_options');
    header('Content-Type: text/javascript');
    if($options) {
        echo "$cb&&$cb(".json_encode(get_user_option('instantsuggest_options')).");";
    }
    die;
}
add_action('wp_ajax_instantsuggest_load_options', 'instantsuggest_load_options');

function instantsuggest_save_options() {
    check_ajax_referer('instantsuggest-save-options', 'security', true);
    $options = $_REQUEST['options'];
    update_user_option(get_current_user_id(), 'instantsuggest_options', $options);
    header('Content-Type: text/javascript');
    die;
}
add_action('wp_ajax_instantsuggest_save_options', 'instantsuggest_save_options');
?>